// vorm.class
// Worm.class
// Food.class
// Vector2D.class

//	Interesting stuff:
// x Alive is defined as dieCounter == 0
// x The death cycle is defined as 0 < dieCounter < READY (a constant)
// x Death is initiated when dieCounter > 0 (i.e. whenever you see dieCounter = 1)
// x The game is ready to go again at dieCounter == READY
// x Scoring: 1 for each food + whatever the food clock reads
// x All the original sounds were made by various sound effects from me and a bit of manipulating with Sound Recorder
// x And no body parts below my neck were used.
// x die.au is made by the last 1/4th of me going "doh~!" slowed down
// x woohoohoohui.au is actually made by me saying "woo hoo hoo hui" in a high voice and obfuscated a bit
// x The worm is a vegan.  That is why only fruits are used.
// x Why is this called vorm? It could be Vector-based wORM.  Or maybe Vegan wORM.  Who knows.
// x Strawberries are my favorite fruit.


// Imports
import java.applet.*;
import java.awt.*;
import java.util.Random;
import java.util.Vector;
import java.net.URL;
import java.net.MalformedURLException;

public class vorm extends Applet implements Runnable {
	Worm player = new Worm();
	Food food = new Food();
	int score = 0;

	Thread thread;

	String titleStr = new String("Vorm v1.0");
	String start = new String("Click to begin || Left and right arrow keys to move");
	String creator = new String("By Eric Choi (c) 2004");
	String scoring = new String("Scoring: 1 point per food + time left on Food Clock");

	Graphics buffer;	//double buffering
	Image bufferimage;	//double buffering

	Font titleFont = new Font("Helvetica", Font.BOLD, 22);
	Font finePrint = new Font("Helvetica", 0, 12);
	Font scoreFont = new Font("Helvetica", 0, 14);
	Color white = new Color(1.0f, 1.0f, 1.0f);
	Color black = new Color(0.0f, 0.0f, 0.0f);

//Resources
	AudioClip spawn;
	AudioClip die;
	AudioClip tick;
	AudioClip eat;

	Image imgFood[] = new Image[5];
	Image imgDot[] = new Image[4];		// Body of worm
	Image bgImage[] = new Image[3];
	int whichColor = 0;
	int whichBG = 0;

	boolean paused;
	boolean left;
	boolean right;

	final int READY = 20;
	int dieCounter = READY;			//Counter for a slight delay after player dies
	long lastAge;				// Used to determine when to play ticking sound

	public void init() {
		Random numGen = new Random();
		whichBG = numGen.nextInt(3);
////**** Load resources
		try {
			spawn = getAudioClip(new URL(getDocumentBase(), "res/woohoohoohui.au"));
			die = getAudioClip(new URL(getDocumentBase(), "res/die.au"));
			eat = getAudioClip(new URL(getDocumentBase(), "res/pop.au"));
			tick = getAudioClip(new URL(getDocumentBase(), "res/tick.au"));

			imgFood[0] = getImage(getCodeBase(), "res/apple.gif");
			imgFood[1] = getImage(getCodeBase(), "res/grapes.gif");
			imgFood[2] = getImage(getCodeBase(), "res/pear.gif");		// to all you pear-shaped people
			imgFood[3] = getImage(getCodeBase(), "res/strawberry.gif");
			imgFood[4] = getImage(getCodeBase(), "res/watermelon.gif");
			imgDot[0] = getImage(getCodeBase(), "res/reddot.gif");
			imgDot[1] = getImage(getCodeBase(), "res/greendot.gif");
			imgDot[2] = getImage(getCodeBase(), "res/bluedot.gif");
			imgDot[3] = getImage(getCodeBase(), "res/yellowdot.gif");

			bgImage[0] = getImage(getCodeBase(), "res/bg0.jpg");
			bgImage[1] = getImage(getCodeBase(), "res/bg1.jpg");							bgImage[2] = getImage(getCodeBase(), "res/bg2.jpg");
		}
		catch (MalformedURLException e) {
			System.out.println(e.getMessage());
		}
////****
		paused = false;
		left = false;
		right = false;
	}

	public void start() {
		if(thread == null) {
			thread = new Thread(this);
			thread.start();
		}
		thread.run();
	}

	public void stop() {
		if(thread != null) {
			thread.stop();
			thread = null;
		}
	}

	public void run() {
		while((Thread.currentThread() == thread)) {
									//Update everything
			long t = System.currentTimeMillis();
	// If player isn't dead and game isn't over (which is defined as dieCounter == READY)
			if(dieCounter == 0) {
//** DO main loop
				player.doUpdate();
				if(left) player.turnLeft();
				if(right) player.turnRight();

				food.doUpdate();

		//* Collision testing block

				Vector2D headSeg = (Vector2D)player.getSegment(0);

				// See if player is eating itself
				for(int i=10; i<player.numSegments(); i++) {	// cut out the first ten because worm ain't	
										// that flexible!
					Vector2D secondSeg = (Vector2D)player.getSegment(i);

					if(distance(headSeg.getX(), headSeg.getY(),
							secondSeg.getX(), secondSeg.getY()) <= 8.0f) {
						dieCounter = 1;	// Initiate death sequence
						die.play();
					}
				}

				// See if player is out of bounds
				if(headSeg.getX() <= 3.0f || headSeg.getX() >= 497.0f ||
						headSeg.getY() <= 3.0f || headSeg.getY() >= 497.0f) {
					dieCounter = 1;
					die.play();
				}

				// Do the bouncy thingy with food
				if(food.getX() <= 7.0f && food.getDX() < 0) {
					Vector2D foodVector = food.getVector();
					foodVector.setVector(food.getX(), food.getY(), -food.getDX(), food.getDY());
				}
				if(food.getX() >= 493.0f && food.getDX() > 0) {
					Vector2D foodVector = food.getVector();
					foodVector.setVector(food.getX(), food.getY(), -food.getDX(), food.getDY());
				}
				if(food.getY() <= 7.0f && food.getDY() < 0) {
					Vector2D foodVector = food.getVector();
					foodVector.setVector(food.getX(), food.getY(), food.getDX(), -food.getDY());
				}
				if(food.getY() >= 493.0f && food.getDY() > 0) {
					Vector2D foodVector = food.getVector();
					foodVector.setVector(food.getX(), food.getY(), food.getDX(), -food.getDY());
				}

				if(lastAge != food.getAge() && food.getAge() <= 5) tick.play();
					lastAge = food.getAge();

				// See if player is hitting food
				Vector2D temp = (Vector2D)player.getSegment(0);
				if(distance(temp.getX(), temp.getY(), food.getX(), food.getY()) <= 11.0f) {
					eat.play();
					player.addSegment();
					food.spawn();
					score++;
					if(food.getAge() <= 5) score += 5 - food.getAge();
				}
//** END DOING main loop
			}
			else if(dieCounter < READY) {
				dieCounter++;
			}

			repaint();
			try {
				t += 40;	// 40 milliseconds per frame
				thread.sleep(Math.max(0, t-System.currentTimeMillis()));
			}
			catch (InterruptedException e) {
				System.out.println(e.getMessage());
				break;
			}
		}
	}

	public void update(Graphics g) {
		if(buffer == null) {
			bufferimage = createImage(500, 500);
			buffer = bufferimage.getGraphics();
		}

//** DO drawing**//

//		buffer.setColor(white);
//		buffer.fillRect(0, 0, 500, 500);
		buffer.drawImage(bgImage[whichBG], 0, 0, this);

		// Drawing for when game is in progress
		if(dieCounter == 0) {
			buffer.drawImage(imgFood[food.getSprite()], (int)food.getX()-7, (int)food.getY()-7, this);

			for(int i=0; i<player.numSegments(); i++) {
				int top = (int)player.getSegment(i).getY() - 4;
				int left = (int)player.getSegment(i).getX() - 4;
				buffer.drawImage(imgDot[whichColor], left, top, this);
			}

			buffer.setColor(black);
			buffer.setFont(scoreFont);
			if(5 - food.getAge() > 0)
				buffer.drawString("Food Clock: " + (5-food.getAge()), 390, 20);
			else
				buffer.drawString("Food Clock: 0", 390, 20);
		}
		else {
			FontMetrics fm = buffer.getFontMetrics(titleFont);
			FontMetrics fp = buffer.getFontMetrics(finePrint);

			buffer.setColor(black);
			buffer.setFont(titleFont);
			buffer.drawString(titleStr, (500 - fm.stringWidth(titleStr)) / 2,
				((500 - fm.getHeight()) / 2) + fm.getAscent());

			buffer.setFont(finePrint);
			buffer.drawString(start, (500 - fp.stringWidth(start)) / 2,
				((500 - fp.getHeight()) / 2) + fp.getAscent()+20);
			buffer.drawString(scoring, 10, 40);
			buffer.drawString(creator, 10, 480);

			buffer.setFont(scoreFont);
			buffer.drawString("Food Clock: 0", 390, 20);	// Bogus reading

		}

		buffer.setFont(scoreFont);
		buffer.drawString("Score: " + score, 10, 20);

		buffer.drawRect(0, 0, 499, 499);
//** END DOING drawing **//
		g.drawImage(bufferimage, 0, 0, null);
	}

	public boolean keyDown(Event evt, int key) {
		if(key == Event.LEFT) left = true;
		if(key == Event.RIGHT) right = true;
		return true;
	}

	public boolean keyUp(Event evt, int key) {
		if(key == Event.LEFT) left = false;
		if(key == Event.RIGHT) right = false;
		return true;
	}

	public boolean mouseDown(Event evt, int x, int y) {
		if(dieCounter == READY) newGame();
		return true;
	}

	public void newGame() {
		lastAge = 0;
		score = 0;
		paused = false;
		dieCounter = 0;
		player.spawn();
		food.spawn();
		spawn.play();
		Random numGen = new Random();
		whichColor = numGen.nextInt(4);
	}

	public float distance(float x1, float y1, float x2, float y2) {
		return (float)Math.sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
	}
}

class Worm {
	protected Vector segments = new Vector(6);

	public Worm() {
		segments.add(new Vector2D(70.0f, 20.0f, 8.0f, 0.0f));
		segments.add(new Vector2D(60.0f, 20.0f, 0.0f, 0.0f));
		segments.add(new Vector2D(50.0f, 20.0f, 0.0f, 0.0f));
		segments.add(new Vector2D(40.0f, 20.0f, 0.0f, 0.0f));
		segments.add(new Vector2D(30.0f, 20.0f, 0.0f, 0.0f));
	}

	public void spawn() {
		segments.clear();
		segments.add(new Vector2D(70.0f, 20.0f, 8.0f, 0.0f));
		segments.add(new Vector2D(60.0f, 20.0f, 0.0f, 0.0f));
		segments.add(new Vector2D(50.0f, 20.0f, 0.0f, 0.0f));
		segments.add(new Vector2D(40.0f, 20.0f, 0.0f, 0.0f));
		segments.add(new Vector2D(30.0f, 20.0f, 0.0f, 0.0f));
	}

	public void addSegment() {
		Vector2D temp = (Vector2D)segments.get(segments.size()-1);	// Get the last one
		segments.add(new Vector2D(temp.getX(), temp.getY(), temp.getDX(), temp.getDY()));
		segments.add(new Vector2D(temp.getX(), temp.getY(), temp.getDX(), temp.getDY()));  // Grow a little faster
											// (steroids are bad for you!!)
	}

	public void doUpdate() {
		Vector2D temp;
		Vector2D temp2;
		for(int i=segments.size()-1; i>=1; i--)
		{
			temp = (Vector2D)segments.get(i);
			temp2 = (Vector2D)segments.get(i-1);
			temp.setVector(temp2);	// Each segment
						// Becomes the one before it
		}

		temp = (Vector2D)segments.get(0);
		temp.move();		// Then the head one moves
	}

	public void turnLeft() {
		Vector2D temp = (Vector2D)segments.get(0);
		temp.rotate(-0.261799f);
	}

	public void turnRight() {
		Vector2D temp = (Vector2D)segments.get(0);
		temp.rotate(0.261799f);
	}

	public int numSegments() {
		return segments.size();
	}

	public Vector2D getSegment(int index) {
		return (Vector2D)segments.get(index);
	}
}

class Food {
	protected Vector2D pos = new Vector2D(0.0f, 0.0f, 0.0f, 0.0f);
	protected int whichSprite;		// what kind of food it looks like
	Random numGen = new Random();
	protected long age;
	protected long bornTime;
	protected long currTime;

	public Food() {
		spawn();
	}

	public void spawn() {
		float x = numGen.nextFloat() * 490.0f + 5;	// nextFloat returns from 0 to 1.0
		float y = numGen.nextFloat() * 490.0f + 5;	// And keep food away from the walls
								// by applying an offset

		float radians = numGen.nextFloat() * 2.0f * (float)Math.PI; // Point in some direction
		pos.setVector(x, y, 2.0f * (float)Math.cos(radians), 2.0f * (float)Math.sin(radians));

		whichSprite = numGen.nextInt(5);	// 0 through 4

		bornTime = System.currentTimeMillis();
		currTime = bornTime;
	}

	public void doUpdate() {
		currTime = System.currentTimeMillis();
		age = (int)Math.floor((double)(currTime - bornTime) / 1000.0);	// Another victim of strict typecasting
		pos.move();
	}

	public Vector2D getVector() {
		return pos;
	}

	public int getSprite() {
		return whichSprite;
	}
	public float getX() {
		return pos.getX();
	}
	public float getY() {
		return pos.getY();
	}
	public float getDX() {
		return pos.getDX();
	}
	public float getDY() {
		return pos.getDY();
	}
	public float getAngle() {
		return pos.getAngle();
	}
	public long getAge() {
		return age;
	}
}

class Vector2D {
	protected float x;		// Point
	protected float y;
	protected float dx;		// Direction
	protected float dy;
	

	public Vector2D(float fx, float fy, float fdx, float fdy) {
		x = fx;
		y = fy;
		dx = fdx;
		dy = fdy;
	}

	public void setVector(float fx, float fy, float fdx, float fdy) {
		x = fx;
		y = fy;
		dx = fdx;
		dy = fdy;
	}

	public void setVector(Vector2D src)
	{
		x = src.x;
		y = src.y;
		dx = src.dx;
		dy = src.dy;
	}

	public void rotate(float radians) {
		// Kinda cheated here.  If I use getLength() * cos(angle) the length
		// steadily shrinks until the length approaches 0, and then nothing moves.
		dx = 8.0f * (float)Math.cos(getAngle() + radians);
		dy = 8.0f * (float)Math.sin(getAngle() + radians);
	}
	
	public float getAngle() {
		if(dx == 0) {
			if(dy > 0)
				return (float)Math.PI/2.0f;
			else
				return (float)-Math.PI/2.0f;
		}
		if(dx > 0)
			return (float)Math.atan(dy/dx);

		return (float)Math.atan(dy/dx)+(float)Math.PI;
	}

	public void move() {
		x += dx;
		y += dy;
	}

	public void setLength(float desiredLength) {
		float ratio = desiredLength / getLength();
		dx *= ratio;
		dy *= ratio;
	}

	public float getLength() {
		if(dx == 0 && dy == 0) return 0; 
		return (float)Math.sqrt((dx)*(dx) + (dy)*(dy));
	}

	public float getX() {
		return x;
	}
	public float getY() {
		return y;
	}
	public float getDX() {
		return dx;
	}
	public float getDY() {
		return dy;
	}
}